diff --git a/sys/dev/usb/controller/xhci_dbc.h b/sys/dev/usb/controller/xhci_dbc.h
new file mode 100644
index 000000000000..47522576fcd7
--- /dev/null
+++ b/sys/dev/usb/controller/xhci_dbc.h
@@ -0,0 +1,191 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+/* DbC idVendor and idProduct */
+#define DC_VENDOR	0x1d6b	/* Linux Foundation */
+#define DC_PRODUCT	0x0011	/* Linux */ 
+#define DC_PROTOCOL	0x0000	/* GNU GDB = 1 */
+#define DC_REVISION	0x0010	/* 1.0 */
+
+#define	DC_STRING_MANUFACTURER	"The FreeBSD Foundation"
+#define	DC_STRING_PRODUCT	"FreeBSD USB DbC Serial"
+#define	DC_STRING_SERIAL	"12345678"
+
+#define XHCI_DCPORTSC_ACK_MASK	\
+	(XHCI_DCPORTSC_PED | \
+	 XHCI_DCPORTSC_CSC | XHCI_DCPORTSC_PRC | \
+	 XHCI_DCPORTSC_PLC | XHCI_DCPORTSC_CEC)
+
+/* DbC endpoint types */
+enum {
+	EP_BULK_OUT = 2,
+	EP_BULK_IN = 6
+};
+
+#define UDB_TRB_PER_PAGE (XHCI_PAGE_SIZE / sizeof(struct xhci_trb))
+
+/* Defines the size in bytes of TRB rings as 2^UDB_TRB_RING_ORDER * 4096 */
+#define UDB_TRB_RING_ORDER	4
+#define UDB_TRB_RING_LEN (UDB_TRB_PER_PAGE * (1ULL << UDB_TRB_RING_ORDER))
+#define UDB_TRB_RING_OFFSET_MASK (UDB_TRB_RING_LEN - 1U)
+#define UDB_TRB_RING_LAST	(UDB_TRB_RING_LEN - 1U)
+#define UDB_TRB_RING_BYTES	(UDB_TRB_RING_LEN * sizeof(struct xhci_trb))
+#define UDB_TRB_RING_MASK	(UDB_TRB_RING_BYTES - 1U)
+
+/* Defines the size in bytes of work rings as 2^WORK_RING_ORDER * 4096 */
+#define	UDB_WORK_RING_ORDER	3
+#define UDB_WORK_RING_LEN	(XHCI_PAGE_SIZE * (1ULL << UDB_WORK_RING_ORDER))
+#define UDB_WORK_RING_OFFSET_MASK	(UDB_WORK_RING_LEN - 1U)
+#define UDB_WORK_RING_LAST	(UDB_WORK_RING_LEN - 1U)
+#define	UDB_WORK_RING_BYTES	UDB_WORK_RING_LEN
+
+#define	UDB_WORK_RING_FULL(r) \
+	((((r)->work.enq + 1) & UDB_WORK_RING_OFFSET_MASK) == (r)->work.deq)
+#define	UDB_WORK_RING_EMPTY(r) \
+	((r)->work.enq == (r)->work.deq)
+#define	XHCI_DEBUG_RING_FULL(r) \
+	((((r)->enq + 1) & UDB_TRB_RING_OFFSET_MASK) == (r)->deq)
+#define	XHCI_DEBUG_RING_EMPTY(r) \
+	((r)->enq == (r)->deq)
+
+struct xhci_debug_reg {
+	uint32_t id;
+	uint32_t doorbell;
+	uint32_t erstsz;
+	uint32_t rsvdz;
+	uint64_t erstba;
+	uint64_t erdp;
+	uint32_t ctrl;
+	uint32_t st;
+	uint32_t portsc;
+	uint32_t rsvdp;
+	uint64_t cp;
+	uint32_t ddi1;
+	uint32_t ddi2;
+};
+
+struct xhci_debug_ctx {
+	uint32_t info[16];
+	struct xhci_endp_ctx64 ep_out;
+	struct xhci_endp_ctx64 ep_in;
+};
+
+struct xhci_debug_work_ring {
+	uint8_t *buf;
+	uint32_t enq;
+	uint32_t deq;
+	uint64_t paddr;
+};
+
+struct xhci_debug_ring {
+	struct xhci_trb *trb;	/* Array of TRBs */
+	uint64_t paddr;		/* base address of TRBs */
+	uint32_t enq;		/* The offset of the enqueue ptr */
+	uint32_t deq;		/* The offset of the dequeue ptr */
+	uint8_t cyc;		/* Cycle state toggled on each wrap-around */
+	uint32_t doorbell;	/* Doorbell target */
+
+	struct xhci_debug_work_ring work;
+};
+
+#ifndef _KERNEL
+#define DMA_DESC_CAP 16
+struct dma {
+	UINTN pages;
+	EFI_PHYSICAL_ADDRESS paddr;
+	VOID *cpu_addr;
+	VOID *mapping;
+};
+#endif
+
+/*
+ * This softc is used in kernel and loader.
+ */
+struct xhci_debug_softc {
+	struct xhci_debug_reg reg;
+	struct xhci_debug_ctx *udb_ctx;
+	uint64_t udb_ctx_paddr;
+	struct xhci_event_ring_seg *udb_erst;
+	uint64_t udb_erst_paddr;
+	struct xhci_debug_ring udb_ering;
+	struct xhci_debug_ring udb_oring;
+	struct xhci_debug_ring udb_iring;
+	char *udb_str;
+	uint64_t udb_str_paddr;
+	struct xhci_debug_softc *sc_udb;
+
+	uint32_t sc_state;
+	uint64_t sc_polling_count;
+	bool sc_init;
+	bool sc_fixup_done;
+	bool sc_open;
+	bool dma_allocated;
+	uint32_t sc_dbc_off;	/* in kernel, struct xhci_softc is used */
+
+#ifdef _KERNEL
+	struct xhci_softc	*sc_xhci;
+#else
+	/*
+	 * XXX: X{READ,WRITE}4 macro in a loader will use sc_mmio_phys
+	 * instead of bus_dma(9) at this moment.
+	 */
+	volatile uintptr_t sc_mmio_phys;
+	uint64_t sc_mmio_size;
+	void *sc_mmio;
+	uint32_t sc_capa_off;
+
+	EFI_HANDLE		sc_efi_hand;
+	EFI_PCI_IO_PROTOCOL	*sc_efi_pciio;
+	uint32_t sc_ca;
+	struct dma dma_desc[DMA_DESC_CAP];
+
+	struct console *sc_cons;
+#endif
+};
+
+int xhci_debug_probe(struct xhci_debug_softc *);
+bool xhci_debug_enable(struct xhci_debug_softc *);
+void xhci_debug_disable(struct xhci_debug_softc *);
+
+int xhci_debug_init_ring(struct xhci_debug_softc *);
+void xhci_debug_update_state(struct xhci_debug_softc *);
+
+ssize_t xhci_debug_bulk_transfer(struct xhci_debug_softc *,
+    struct xhci_debug_ring *);
+bool xhci_debug_event_ready(struct xhci_debug_softc *);
+void xhci_debug_event_dequeue(struct xhci_debug_softc *);
+
+int work_dequeue(struct xhci_debug_ring *);
+int64_t work_enqueue(struct xhci_debug_ring *, const char *, int64_t);
+
+void udb_dump_info(struct xhci_debug_softc *);
+void udb_info(void);
+
+#ifdef _KERNEL
+int udbcons_init(struct xhci_softc *, device_t);
+#endif
diff --git a/sys/dev/usb/controller/xhci_dbc_private.h b/sys/dev/usb/controller/xhci_dbc_private.h
new file mode 100644
index 000000000000..748fe8c910c0
--- /dev/null
+++ b/sys/dev/usb/controller/xhci_dbc_private.h
@@ -0,0 +1,78 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+
+#if 0
+#define	DEBUG
+#endif
+#if 0
+#define	DEBUG_VERBOSE
+#endif
+
+#if defined(DEBUG)
+#define	DEBUG_PRINTF(...)       printf(__VA_ARGS__)
+#else
+#define	DEBUG_PRINTF(...)
+#endif
+#if defined(DEBUG) && defined(DEBUG_VERBOSE)
+#define	DEBUG_V_PRINTF(...)     printf(__VA_ARGS__)
+#else
+#define	DEBUG_V_PRINTF(...)
+#endif
+
+#define LFENCE(x)	__asm volatile("lfence" ::: "memory")
+
+#ifdef _KERNEL
+#define	_XREAD4(sc, what, a)		XREAD4((sc)->sc_xhci, what, a)
+#define	_XWRITE4(sc, what, a, x)	XWRITE4((sc)->sc_xhci, what, a, (x))
+#define	_XREAD44LH(sc, what, a)		XREAD44LH((sc)->sc_xhci, what, a)
+#define	_XWRITE44LH(sc, what, a, x) XWRITE44LH((sc)->sc_xhci, what, a, (x))
+/* sys/systm.h */
+#define	delay(x)	DELAY(x)
+
+#else
+
+/* Read/write macros for MMIO space */
+#define	_XREAD4(sc, what, a)	\
+	(*((volatile uint32_t *) \
+	 ((sc)->sc_mmio_phys + (a) + (sc)->sc_##what##_off)))
+#define	_XREAD44LH(sc, what, a)	\
+	((uint64_t)_XREAD4(sc, what, a##_LO) | \
+	     ((uint64_t)_XREAD4(sc, what, a##_HI) << 32)) 
+#define	_XWRITE4(sc, what, a, x) \
+	do { \
+		__asm volatile("sfence" ::: "memory"); \
+		*((volatile uint32_t *) \
+		 ((sc)->sc_mmio_phys + (a) + (sc)->sc_##what##_off)) = (x); \
+		__asm volatile("sfence" ::: "memory"); \
+	} while (0)
+#define	_XWRITE44LH(sc, what, a, x) \
+	do { \
+		_XWRITE4(sc, what, a##_LO, (uint32_t)((x) & 0xffffffff)); \
+		_XWRITE4(sc, what, a##_HI, (uint32_t)((x) >> 32)); \
+	} while (0)
+#endif
diff --git a/sys/dev/usb/controller/xhci_private.h b/sys/dev/usb/controller/xhci_private.h
new file mode 100644
index 000000000000..5ed7f019e42e
--- /dev/null
+++ b/sys/dev/usb/controller/xhci_private.h
@@ -0,0 +1,228 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2010-2022 Hans Petter Selasky
+ * Copyright (c) 2020-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _USB_XHCI_PRIVATE_H_
+#define	_USB_XHCI_PRIVATE_H_
+
+#define	XHCI_DEV_CTX_ADDR_ALIGN		64	/* bytes */
+#define	XHCI_DEV_CTX_ALIGN		64	/* bytes */
+#define	XHCI_INPUT_CTX_ALIGN		64	/* bytes */
+#define	XHCI_SLOT_CTX_ALIGN		32	/* bytes */
+#define	XHCI_ENDP_CTX_ALIGN		32	/* bytes */
+#define	XHCI_STREAM_CTX_ALIGN		16	/* bytes */
+#define	XHCI_TRANS_RING_SEG_ALIGN	16	/* bytes */
+#define	XHCI_CMD_RING_SEG_ALIGN		64	/* bytes */
+#define	XHCI_EVENT_RING_SEG_ALIGN	64	/* bytes */
+#define	XHCI_SCRATCH_BUF_ARRAY_ALIGN	64	/* bytes */
+#define	XHCI_SCRATCH_BUFFER_ALIGN	USB_PAGE_SIZE
+#define	XHCI_TRB_ALIGN			16	/* bytes */
+#define	XHCI_TD_ALIGN			64	/* bytes */
+#define	XHCI_PAGE_SIZE			4096	/* bytes */
+
+struct xhci_endp_ctx {
+	volatile uint32_t	dwEpCtx0;
+#define	XHCI_EPCTX_0_EPSTATE_SET(x)		((x) & 0x7)
+#define	XHCI_EPCTX_0_EPSTATE_GET(x)		((x) & 0x7)
+#define	XHCI_EPCTX_0_EPSTATE_DISABLED		0
+#define	XHCI_EPCTX_0_EPSTATE_RUNNING		1
+#define	XHCI_EPCTX_0_EPSTATE_HALTED		2
+#define	XHCI_EPCTX_0_EPSTATE_STOPPED		3
+#define	XHCI_EPCTX_0_EPSTATE_ERROR		4
+#define	XHCI_EPCTX_0_EPSTATE_RESERVED_5		5
+#define	XHCI_EPCTX_0_EPSTATE_RESERVED_6		6
+#define	XHCI_EPCTX_0_EPSTATE_RESERVED_7		7
+#define	XHCI_EPCTX_0_MULT_SET(x)		(((x) & 0x3) << 8)
+#define	XHCI_EPCTX_0_MULT_GET(x)		(((x) >> 8) & 0x3)
+#define	XHCI_EPCTX_0_MAXP_STREAMS_SET(x)	(((x) & 0x1F) << 10)
+#define	XHCI_EPCTX_0_MAXP_STREAMS_GET(x)	(((x) >> 10) & 0x1F)
+#define	XHCI_EPCTX_0_LSA_SET(x)			(((x) & 0x1) << 15)
+#define	XHCI_EPCTX_0_LSA_GET(x)			(((x) >> 15) & 0x1)
+#define	XHCI_EPCTX_0_IVAL_SET(x)		(((x) & 0xFF) << 16)
+#define	XHCI_EPCTX_0_IVAL_GET(x)		(((x) >> 16) & 0xFF)
+	volatile uint32_t	dwEpCtx1;
+#define	XHCI_EPCTX_1_CERR_SET(x)		(((x) & 0x3) << 1)
+#define	XHCI_EPCTX_1_CERR_GET(x)		(((x) >> 1) & 0x3)
+#define	XHCI_EPCTX_1_EPTYPE_SET(x)		(((x) & 0x7) << 3)
+#define	XHCI_EPCTX_1_EPTYPE_GET(x)		(((x) >> 3) & 0x7)
+#define	XHCI_EPCTX_1_HID_SET(x)			(((x) & 0x1) << 7)
+#define	XHCI_EPCTX_1_HID_GET(x)			(((x) >> 7) & 0x1)
+#define	XHCI_EPCTX_1_MAXB_SET(x)		(((x) & 0xFF) << 8)
+#define	XHCI_EPCTX_1_MAXB_GET(x)		(((x) >> 8) & 0xFF)
+#define	XHCI_EPCTX_1_MAXP_SIZE_SET(x)		(((x) & 0xFFFF) << 16)
+#define	XHCI_EPCTX_1_MAXP_SIZE_GET(x)		(((x) >> 16) & 0xFFFF)
+	volatile uint64_t	qwEpCtx2;
+#define	XHCI_EPCTX_2_DCS_SET(x)			((x) & 0x1)
+#define	XHCI_EPCTX_2_DCS_GET(x)			((x) & 0x1)
+#define	XHCI_EPCTX_2_TR_DQ_PTR_MASK		0xFFFFFFFFFFFFFFF0U
+	volatile uint32_t	dwEpCtx4;
+#define	XHCI_EPCTX_4_AVG_TRB_LEN_SET(x)		((x) & 0xFFFF)
+#define	XHCI_EPCTX_4_AVG_TRB_LEN_GET(x)		((x) & 0xFFFF)
+#define	XHCI_EPCTX_4_MAX_ESIT_PAYLOAD_SET(x)	(((x) & 0xFFFF) << 16)
+#define	XHCI_EPCTX_4_MAX_ESIT_PAYLOAD_GET(x)	(((x) >> 16) & 0xFFFF)
+	volatile uint32_t	dwEpCtx5;
+	volatile uint32_t	dwEpCtx6;
+	volatile uint32_t	dwEpCtx7;
+};
+
+struct xhci_endp_ctx64 {
+	struct xhci_endp_ctx	ctx;
+	volatile uint8_t	padding[32];
+};
+
+struct xhci_trb {
+	volatile uint64_t	qwTrb0;
+#define	XHCI_TRB_0_DIR_IN_MASK		(0x80ULL << 0)
+#define	XHCI_TRB_0_WLENGTH_MASK		(0xFFFFULL << 48)
+	volatile uint32_t	dwTrb2;
+#define	XHCI_TRB_2_ERROR_GET(x)		(((x) >> 24) & 0xFF)
+#define	XHCI_TRB_2_ERROR_SET(x)		(((x) & 0xFF) << 24)
+#define	XHCI_TRB_2_TDSZ_GET(x)		(((x) >> 17) & 0x1F)
+#define	XHCI_TRB_2_TDSZ_SET(x)		(((x) & 0x1F) << 17)
+#define	XHCI_TRB_2_REM_GET(x)		((x) & 0xFFFFFF)
+#define	XHCI_TRB_2_REM_SET(x)		((x) & 0xFFFFFF)
+#define	XHCI_TRB_2_BYTES_GET(x)		((x) & 0x1FFFF)
+#define	XHCI_TRB_2_BYTES_SET(x)		((x) & 0x1FFFF)
+#define	XHCI_TRB_2_IRQ_GET(x)		(((x) >> 22) & 0x3FF)
+#define	XHCI_TRB_2_IRQ_SET(x)		(((x) & 0x3FF) << 22)
+#define	XHCI_TRB_2_STREAM_GET(x)	(((x) >> 16) & 0xFFFF)
+#define	XHCI_TRB_2_STREAM_SET(x)	(((x) & 0xFFFF) << 16)
+
+	volatile uint32_t	dwTrb3;
+#define	XHCI_TRB_3_TYPE_GET(x)		(((x) >> 10) & 0x3F)
+#define	XHCI_TRB_3_TYPE_SET(x)		(((x) & 0x3F) << 10)
+#define	XHCI_TRB_3_CYCLE_BIT		(1U << 0)
+#define	XHCI_TRB_3_TC_BIT		(1U << 1)	/* command ring only */
+#define	XHCI_TRB_3_ENT_BIT		(1U << 1)	/* transfer ring only */
+#define	XHCI_TRB_3_ISP_BIT		(1U << 2)
+#define	XHCI_TRB_3_NSNOOP_BIT		(1U << 3)
+#define	XHCI_TRB_3_CHAIN_BIT		(1U << 4)
+#define	XHCI_TRB_3_IOC_BIT		(1U << 5)
+#define	XHCI_TRB_3_IDT_BIT		(1U << 6)
+#define	XHCI_TRB_3_TBC_GET(x)		(((x) >> 7) & 3)
+#define	XHCI_TRB_3_TBC_SET(x)		(((x) & 3) << 7)
+#define	XHCI_TRB_3_BEI_BIT		(1U << 9)
+#define	XHCI_TRB_3_DCEP_BIT		(1U << 9)
+#define	XHCI_TRB_3_PRSV_BIT		(1U << 9)
+#define	XHCI_TRB_3_BSR_BIT		(1U << 9)
+#define	XHCI_TRB_3_TRT_MASK		(3U << 16)
+#define	XHCI_TRB_3_TRT_NONE		(0U << 16)
+#define	XHCI_TRB_3_TRT_OUT		(2U << 16)
+#define	XHCI_TRB_3_TRT_IN		(3U << 16)
+#define	XHCI_TRB_3_DIR_IN		(1U << 16)
+#define	XHCI_TRB_3_TLBPC_GET(x)		(((x) >> 16) & 0xF)
+#define	XHCI_TRB_3_TLBPC_SET(x)		(((x) & 0xF) << 16)
+#define	XHCI_TRB_3_EP_GET(x)		(((x) >> 16) & 0x1F)
+#define	XHCI_TRB_3_EP_SET(x)		(((x) & 0x1F) << 16)
+#define	XHCI_TRB_3_FRID_GET(x)		(((x) >> 20) & 0x7FF)
+#define	XHCI_TRB_3_FRID_SET(x)		(((x) & 0x7FF) << 20)
+#define	XHCI_TRB_3_ISO_SIA_BIT		(1U << 31)
+#define	XHCI_TRB_3_SUSP_EP_BIT		(1U << 23)
+#define	XHCI_TRB_3_SLOT_GET(x)		(((x) >> 24) & 0xFF)
+#define	XHCI_TRB_3_SLOT_SET(x)		(((x) & 0xFF) << 24)
+
+/* Commands */
+#define	XHCI_TRB_TYPE_RESERVED		0x00
+#define	XHCI_TRB_TYPE_NORMAL		0x01
+#define	XHCI_TRB_TYPE_SETUP_STAGE	0x02
+#define	XHCI_TRB_TYPE_DATA_STAGE	0x03
+#define	XHCI_TRB_TYPE_STATUS_STAGE	0x04
+#define	XHCI_TRB_TYPE_ISOCH		0x05
+#define	XHCI_TRB_TYPE_LINK		0x06
+#define	XHCI_TRB_TYPE_EVENT_DATA	0x07
+#define	XHCI_TRB_TYPE_NOOP		0x08
+#define	XHCI_TRB_TYPE_ENABLE_SLOT	0x09
+#define	XHCI_TRB_TYPE_DISABLE_SLOT	0x0A
+#define	XHCI_TRB_TYPE_ADDRESS_DEVICE	0x0B
+#define	XHCI_TRB_TYPE_CONFIGURE_EP	0x0C
+#define	XHCI_TRB_TYPE_EVALUATE_CTX	0x0D
+#define	XHCI_TRB_TYPE_RESET_EP		0x0E
+#define	XHCI_TRB_TYPE_STOP_EP		0x0F
+#define	XHCI_TRB_TYPE_SET_TR_DEQUEUE	0x10
+#define	XHCI_TRB_TYPE_RESET_DEVICE	0x11
+#define	XHCI_TRB_TYPE_FORCE_EVENT	0x12
+#define	XHCI_TRB_TYPE_NEGOTIATE_BW	0x13
+#define	XHCI_TRB_TYPE_SET_LATENCY_TOL  	0x14
+#define	XHCI_TRB_TYPE_GET_PORT_BW	0x15
+#define	XHCI_TRB_TYPE_FORCE_HEADER	0x16
+#define	XHCI_TRB_TYPE_NOOP_CMD		0x17
+
+/* Events */
+#define	XHCI_TRB_EVENT_TRANSFER		0x20
+#define	XHCI_TRB_EVENT_CMD_COMPLETE	0x21
+#define	XHCI_TRB_EVENT_PORT_STS_CHANGE  0x22
+#define	XHCI_TRB_EVENT_BW_REQUEST      	0x23
+#define	XHCI_TRB_EVENT_DOORBELL		0x24
+#define	XHCI_TRB_EVENT_HOST_CTRL	0x25
+#define	XHCI_TRB_EVENT_DEVICE_NOTIFY	0x26
+#define	XHCI_TRB_EVENT_MFINDEX_WRAP	0x27
+
+/* Error codes */
+#define	XHCI_TRB_ERROR_INVALID		0x00
+#define	XHCI_TRB_ERROR_SUCCESS		0x01
+#define	XHCI_TRB_ERROR_DATA_BUF		0x02
+#define	XHCI_TRB_ERROR_BABBLE		0x03
+#define	XHCI_TRB_ERROR_XACT		0x04
+#define	XHCI_TRB_ERROR_TRB		0x05
+#define	XHCI_TRB_ERROR_STALL		0x06
+#define	XHCI_TRB_ERROR_RESOURCE		0x07
+#define	XHCI_TRB_ERROR_BANDWIDTH	0x08
+#define	XHCI_TRB_ERROR_NO_SLOTS		0x09
+#define	XHCI_TRB_ERROR_STREAM_TYPE	0x0A
+#define	XHCI_TRB_ERROR_SLOT_NOT_ON	0x0B
+#define	XHCI_TRB_ERROR_ENDP_NOT_ON	0x0C
+#define	XHCI_TRB_ERROR_SHORT_PKT	0x0D
+#define	XHCI_TRB_ERROR_RING_UNDERRUN	0x0E
+#define	XHCI_TRB_ERROR_RING_OVERRUN	0x0F
+#define	XHCI_TRB_ERROR_VF_RING_FULL	0x10
+#define	XHCI_TRB_ERROR_PARAMETER	0x11
+#define	XHCI_TRB_ERROR_BW_OVERRUN	0x12
+#define	XHCI_TRB_ERROR_CONTEXT_STATE	0x13
+#define	XHCI_TRB_ERROR_NO_PING_RESP	0x14
+#define	XHCI_TRB_ERROR_EV_RING_FULL	0x15
+#define	XHCI_TRB_ERROR_INCOMPAT_DEV	0x16
+#define	XHCI_TRB_ERROR_MISSED_SERVICE	0x17
+#define	XHCI_TRB_ERROR_CMD_RING_STOP	0x18
+#define	XHCI_TRB_ERROR_CMD_ABORTED	0x19
+#define	XHCI_TRB_ERROR_STOPPED		0x1A
+#define	XHCI_TRB_ERROR_LENGTH		0x1B
+#define	XHCI_TRB_ERROR_BAD_MELAT	0x1D
+#define	XHCI_TRB_ERROR_ISOC_OVERRUN	0x1F
+#define	XHCI_TRB_ERROR_EVENT_LOST	0x20
+#define	XHCI_TRB_ERROR_UNDEFINED	0x21
+#define	XHCI_TRB_ERROR_INVALID_SID	0x22
+#define	XHCI_TRB_ERROR_SEC_BW		0x23
+#define	XHCI_TRB_ERROR_SPLIT_XACT	0x24
+} __aligned(4);
+
+struct xhci_event_ring_seg {
+	volatile uint64_t	qwEvrsTablePtr;
+	volatile uint32_t	dwEvrsTableSize;
+	volatile uint32_t	dwEvrsReserved;
+};
+
+#endif					/* _USB_XHCI_PRIVATE_H_ */
diff --git a/sys/dev/usb/controller/xhcireg.h b/sys/dev/usb/controller/xhcireg.h
index 9d0b6e2f4b4b..6bd026dc4659 100644
--- a/sys/dev/usb/controller/xhcireg.h
+++ b/sys/dev/usb/controller/xhcireg.h
@@ -205,6 +205,97 @@
 #define	XHCI_ID_VIRTUALIZATION	0x0004
 #define	XHCI_ID_MSG_IRQ		0x0005
 #define	XHCI_ID_USB_LOCAL_MEM	0x0006
+#define	XHCI_ID_USB_DEBUG	0x000a
+
+/* XHCI Debug Capability */
+#define	XHCI_DCID		0x0000
+#define	XHCI_DCDB		0x0004
+#define	XHCI_DCDB_GET(x)	(((x) >> 8) & 0xFF)
+#define	XHCI_DCDB_MASK		0x0000FF00	/* the other bits are RsvdP */
+#define	XHCI_DCDB_OUT		0x0000
+#define	XHCI_DCDB_IN		0x0100
+#define	XHCI_DCDB_INVAL		0xFF00
+#define	XHCI_DCERSTSZ		0x0008
+#define	XHCI_DCERSTBA_LO	0x0010
+#define	XHCI_DCERSTBA_HI	0x0014
+#define	XHCI_DCERDP_LO		0x0018
+#define	XHCI_DCERDP_HI		0x001C
+#define	XHCI_DCCTRL		0x0020
+#define	XHCI_DCCTRL_DCR		0x00000001
+#define	XHCI_DCCTRL_DCR_GET(x)	(((x)      ) & 0x01)
+#define	XHCI_DCCTRL_LSE		0x00000002
+#define	XHCI_DCCTRL_LSE_GET(x)	(((x) >>  1) & 0x01)
+#define	XHCI_DCCTRL_HOT		0x00000004
+#define	XHCI_DCCTRL_HOT_GET(x)	(((x) >>  2) & 0x01)
+#define	XHCI_DCCTRL_HIT		0x00000008
+#define	XHCI_DCCTRL_HIT_GET(x)	(((x) >>  3) & 0x01)
+#define	XHCI_DCCTRL_DRC		0x00000010
+#define	XHCI_DCCTRL_DRC_GET(x)	(((x) >>  4) & 0x01)
+#define	XHCI_DCCTRL_MBS_GET(x)	(((x) >> 16) & 0xFF)
+#define	XHCI_DCCTRL_ADDR_GET(x)	(((x) >> 24) & 0x07)
+#define	XHCI_DCCTRL_DCE		0x80000000
+#define	XHCI_DCCTRL_DCE_GET(x)	(((x) >> 31) & 0x01)
+#define	XHCI_DCST		0x0024
+#define	XHCI_DCST_ER		0x00000000
+#define	XHCI_DCST_ER_GET(x)	(((x)      ) & 0x01)
+#define	XHCI_DCST_SBR		0x00000004
+#define	XHCI_DCST_SBR_GET(x)	(((x) >>  2) & 0x01)
+#define	XHCI_DCST_PORT_GET(x)	(((x) >> 24) & 0xFF)
+#define	XHCI_DCPORTSC		0x0028
+#define	XHCI_DCPORTSC_CCS	0x00000001
+#define	XHCI_DCPORTSC_CCS_GET(x)	(((x)      ) & 0x01)
+#define	XHCI_DCPORTSC_PED	0x00000002
+#define	XHCI_DCPORTSC_PED_GET(x)	(((x) >>  1) & 0x01)
+#define	XHCI_DCPORTSC_PR	0x00000010
+#define	XHCI_DCPORTSC_PR_GET(x)	(((x) >>  4) & 0x01)
+#define	XHCI_DCPORTSC_PLS_GET(x)	(((x) >>  5) & 0x0F)
+#define	XHCI_DCPORTSC_PLS_U0	0x00
+#define	XHCI_DCPORTSC_PLS_U1	0x01
+#define	XHCI_DCPORTSC_PLS_U2	0x02
+#define	XHCI_DCPORTSC_PLS_U3	0x03
+#define	XHCI_DCPORTSC_PLS_DISABLED	0x04
+#define	XHCI_DCPORTSC_PLS_RXDETECTED	0x05
+#define	XHCI_DCPORTSC_PLS_INACTIVE	0x06
+#define	XHCI_DCPORTSC_PLS_POLLING	0x07
+#define	XHCI_DCPORTSC_PLS_RECOVERY	0x08
+#define	XHCI_DCPORTSC_PLS_HOTRESET	0x09
+#define	XHCI_DCPORTSC_SPEED_GET(x)	(((x) >> 10) & 0x0F)
+#define	XHCI_DCPORTSC_CSC	0x00020000
+#define	XHCI_DCPORTSC_CSC_GET(x)	(((x) >> 17) & 0x01)
+#define	XHCI_DCPORTSC_PRC	0x00200000
+#define	XHCI_DCPORTSC_PRC_GET(x)	(((x) >> 21) & 0x01)
+#define	XHCI_DCPORTSC_PLC	0x00400000
+#define	XHCI_DCPORTSC_PLC_GET(x)	(((x) >> 22) & 0x01)
+#define	XHCI_DCPORTSC_CEC	0x00800000
+#define	XHCI_DCPORTSC_CEC_GET(x)	(((x) >> 23) & 0x01)
+#define	XHCI_DCCP_LO		0x0030
+#define	XHCI_DCCP_HI		0x0034
+#define	XHCI_DCDDI1		0x0038
+#define	XHCI_DCDDI2		0x003C
+
+#define	XHCI_DCSTATUS(ctrl, portsc) \
+	(XHCI_DCCTRL_DCE_GET(ctrl) << 4 | \
+	XHCI_DCPORTSC_CCS_GET(portsc) << 3 | \
+	XHCI_DCPORTSC_PED_GET(portsc) << 2 | \
+	XHCI_DCPORTSC_PR_GET(portsc)  << 1 | \
+	XHCI_DCCTRL_DCR_GET(ctrl))
+#define	XHCI_DCPORT_ST_OFF		0x00
+#define	XHCI_DCPORT_ST_DISCONNECTED	0x10	/* DCE only */
+#define	XHCI_DCPORT_ST_DISABLED		0x18	/* DCE + CCS */
+#define	XHCI_DCPORT_ST_RESETTING	0x1a	/* DCE + CCS + PR */
+#define	XHCI_DCPORT_ST_ENABLED		0x1c	/* DCE + CCS + PED */
+#define	XHCI_DCPORT_ST_CONFIGURED	0x1d	/* DCE + CCS + PED + DCR */
+
+#define	XHCI_DC_MAXPACKETLEN	1024
+/*
+ * While Sec 7.6.3.2 describes Endpoint IDs should be 0 or 1,
+ * Intel chips use Device Context Index (Sec 4.5.1) instead.
+ */
+#define	XHCI_DC_EPID_OUT	0
+#define	XHCI_DC_EPID_IN		1
+#define	XHCI_DC_EPID_OUT_INTEL	2
+#define	XHCI_DC_EPID_IN_INTEL	3
+#define	XHCI_DC_SLOT		1
 
 /* XHCI register R/W wrappers */
 #define	XREAD1(sc, what, a) \
@@ -216,6 +307,9 @@
 #define	XREAD4(sc, what, a) \
 	bus_space_read_4((sc)->sc_io_tag, (sc)->sc_io_hdl, \
 		(a) + (sc)->sc_##what##_off)
+#define	XREAD44LH(sc, what, a) \
+	((uint64_t)XREAD4((sc), what, a##_LO) | \
+	    ((uint64_t)XREAD4((sc), what, a##_HI) << 32))
 #define	XWRITE1(sc, what, a, x) \
 	bus_space_write_1((sc)->sc_io_tag, (sc)->sc_io_hdl, \
 		(a) + (sc)->sc_##what##_off, (x))
@@ -225,5 +319,10 @@
 #define	XWRITE4(sc, what, a, x) \
 	bus_space_write_4((sc)->sc_io_tag, (sc)->sc_io_hdl, \
 		(a) + (sc)->sc_##what##_off, (x))
+#define	XWRITE44LH(sc, what, a, x) \
+	do { \
+		XWRITE4((sc), what, a##_LO, (uint32_t)((x) & 0xffffffff)); \
+		XWRITE4((sc), what, a##_HI, (uint32_t)((x) >> 32)); \
+	} while (0)
 
 #endif	/* _XHCIREG_H_ */
diff --git a/sys/dev/usb/net/if_usie.c b/sys/dev/usb/net/if_usie.c
index aaab89a23e9e..aff8ec86d8f7 100644
--- a/sys/dev/usb/net/if_usie.c
+++ b/sys/dev/usb/net/if_usie.c
@@ -431,11 +431,6 @@ usie_attach(device_t self)
 
 	/* setup ifnet (Direct IP) */
 	sc->sc_ifp = ifp = if_alloc(IFT_OTHER);
-
-	if (ifp == NULL) {
-		device_printf(self, "Could not allocate a network interface\n");
-		goto detach;
-	}
 	if_initname(ifp, "usie", device_get_unit(self));
 
 	if_setsoftc(ifp, sc);
diff --git a/sys/dev/usb/net/uhso.c b/sys/dev/usb/net/uhso.c
index 14826734f6aa..9513dbeae029 100644
--- a/sys/dev/usb/net/uhso.c
+++ b/sys/dev/usb/net/uhso.c
@@ -1566,10 +1566,6 @@ uhso_attach_ifnet(struct uhso_softc *sc, struct usb_interface *iface, int type)
 	}
 
 	sc->sc_ifp = ifp = if_alloc(IFT_OTHER);
-	if (sc->sc_ifp == NULL) {
-		device_printf(sc->sc_dev, "if_alloc() failed\n");
-		return (-1);
-	}
 
 	callout_init_mtx(&sc->sc_c, &sc->sc_mtx, 0);
 	mtx_lock(&sc->sc_mtx);
diff --git a/sys/dev/usb/net/usb_ethernet.c b/sys/dev/usb/net/usb_ethernet.c
index 2b90c9249855..1efd82ccda13 100644
--- a/sys/dev/usb/net/usb_ethernet.c
+++ b/sys/dev/usb/net/usb_ethernet.c
@@ -221,11 +221,6 @@ ue_attach_post_task(struct usb_proc_msg *_task)
 	error = 0;
 	CURVNET_SET_QUIET(vnet0);
 	ifp = if_alloc(IFT_ETHER);
-	if (ifp == NULL) {
-		device_printf(ue->ue_dev, "could not allocate ifnet\n");
-		goto fail;
-	}
-
 	if_setsoftc(ifp, ue);
 	if_initname(ifp, "ue", ue->ue_unit);
 	if (ue->ue_methods->ue_attach_post_sub != NULL) {
diff --git a/sys/dev/usb/serial/u3g.c b/sys/dev/usb/serial/u3g.c
index e0a1ff29b0a4..88f94ddaecc6 100644
--- a/sys/dev/usb/serial/u3g.c
+++ b/sys/dev/usb/serial/u3g.c
@@ -205,6 +205,7 @@ static const STRUCT_USB_HOST_ID u3g_devs[] = {
 	U3G_DEV(ALINK, 3GU, 0),
 	U3G_DEV(ALINK, DWM652U5, 0),
 	U3G_DEV(ALINK, SIM7600E, 0),
+	U3G_DEV(ALINK, SIM7600G, 0),
 	U3G_DEV(AMOI, H01, 0),
 	U3G_DEV(AMOI, H01A, 0),
 	U3G_DEV(AMOI, H02, 0),
